<?php

/*-----------------------------------------------------------------------------------*/
/*	This is a setup file for Massive Panel
/*-----------------------------------------------------------------------------------*/

function mpcrf_options() {

	$rfbwp_shortname = "rfbwp";
	// Sidebar Array
	$sidebar_array = array("left" => "Left", "right" => "Right", "none" => "None");
	$template_root = MPC_PLUGIN_ROOT;

	// Socials Array
	$social_array = array(
		'support' => array( 'dashicons-sos', __( 'Support' ), 'http://mpc.ticksy.com' ),
		'facebook' => array( 'dashicons-facebook-alt', __( 'Facebook' ), 'https://www.facebook.com/MassivePixelCreation' ),
		'twitter' => array( 'dashicons-twitter', __( 'Twitter' ), 'http://twitter.com/mpcreation' ),
	);

	//number of footer columns
	$number_of_columns = array('1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5');

	// this array is used for images example (first attribute of the image is used as a description for the image, the second is the path
	$images_array = array("Patern 1" => "patterns/p1.png",
		"Pattern 2" => "patterns/p2.png",
		"Pattern 3" => "patterns/p3.png",
		"Pattern 4" => "patterns/p4.png",
		"Pattern 5" => "patterns/p5.png",
		"Pattern 6" => "patterns/p6.png",
		"Pattern 7" => "patterns/p7.png",
		"Pattern 8" => "patterns/p8.png",
		"Pattern 9" => "patterns/p9.png",
		"Pattern 10" => "patterns/p10.png",
		"Pattern 11" => "patterns/p11.jpg",
		"No Pattern" => "patterns/p12.png");

	// This array is only used as an example
	$test_array = array("one" => __( "One" ), "two" => __( "Two" ), "three" => __( "Three" ), "four" => __( "Four" ), "five" => __( "Five" ));
	$lbox_or_link_array = array("lightbox" => __( "Lightbox" ),"post_link" => __( "Link to Post" ) );

	// this array is used for the portfolio module
	$columns_array = array("1" => "1", "2" => "2", "3" => "3", "4" => "4");

	// Pull all the categories into an array
	$options_categories = array();
	$options_categories_obj = get_categories();
	foreach ($options_categories_obj as $category) {
		$options_categories[$category->cat_ID] = $category->cat_name;
	}

	// Pull all the pages into an array
	$options_pages = array();
	$options_pages_obj = get_pages('sort_column=post_parent,menu_order');
	$options_pages[''] = 'Select a page:';
	foreach ($options_pages_obj as $page) {
		$options_pages[$page->ID] = $page->post_title;
	}

	// Options for single page - Portfolio and Blog
	$options_single = array("blog" => __( "Blog" ), "portfolio" => __( "Portfolio" ));

	// Pull all the pages that are type protfolio
	$portfolio_pages = array();
	$portfolio_pages_obj = get_pages('sort_column=post_parent,menu_order');
	$portfolio_pages[''] = 'Select a page:';
	foreach ($portfolio_pages_obj as $page) {
		if(get_post_meta( $page->ID, '_wp_page_template', true) == "portfolio.php") // nazwe default zmieniamy na nazwe template naprzyklad portfolio.php
			$portfolio_pages[$page->ID] = $page->post_title;
	}

	$options = array();

	// General section
	$options[] = array(
		"name" => __( "Flip Books" ), // When option is type section that mean that it will be displayed as button on the left
		"sub-name" => __(  "All settings" ),
		"icon" => "", // icon has to be placed in massive-panel/images/icons folder
		"icon-active" => "",
		"type" => "section"
	);

	$options[] = array(
		"name" => __( "Books" ), // Options of type heading represent tabs for sections
		"type" => "heading"
	);

	$options[] = array(
		"name" => __( "Books" ),
		"type" => "books",
		"id" => $rfbwp_shortname."_books"
	);

	$options[] = array(
		"name" => "Settings_0", // Options of type heading represent tabs for sections
		"type" => "heading",
		"sub" => "settings"
	);

	$options[] = array(
		"name" => __( "Name" ), // this defines the heading of the option
		"desc" => __( "Book Name: " ), // this is the field/option description
		"desc-pos" => "top",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Flip book name is used to generate a unique shortcode for the book (NOTE: Please use only laters, numbers and spaces), width and height are used to specify books dimantions.' ), // text for the help tool tip
		"help-pos" => "bottom",
		"id"   => $rfbwp_shortname."_fb_name", // the id must be unique, it is used to call back the propertie inside the theme
		"std"  => "", // deafult value of the text
		"validation" => "nohtml", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-medium",
		"toggle" => "begin",
		"toggle-name" => __( "Main" )
	);

	$options[] = array(
		"name" => __( "Page Width:" ), // this defines the heading of the option
		"desc" => __( "Page Width:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_width", // the id must be unique, it is used to call back the propertie inside the them
		//"std"  => "346", // deafult value of the text
		"std"   => "",
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Book Height:" ), // this defines the heading of the option
		"desc" => __( "Page Height:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_height", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "490", // deafult value of the text
		"std"   => "",
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end"
	);

	$options[ ] = array(
		'name'        => __( 'Always open', 'rfbwp' ),
		'desc'        => __( 'Always open:', 'rfbwp' ),
		'desc-pos'    => 'top',
		'id'          => $rfbwp_shortname . '_fb_force_open',
		'std'         => '0',
		'type'        => 'checkbox',
		'help'        => 'true',
		'help-desc'   => __( 'Select this option to prevent the book from closing.', 'rfbwp' ),
		'help-pos'    => 'top',
	);
	
/*	$options[ ] = array(
		'name'        => __( 'Download Preset', 'rfbwp' ),
		'desc'        => __( 'Download Preset:', 'rfbwp' ),
		'desc-pos'    => 'top',
		'id'          => $rfbwp_shortname . '_fb_down_preset',
		'std'         => '0',
		'type'        => 'checkbox',
		'class'		  => 'export_preset',
		'help'        => 'true',
		'help-desc'   => __( 'Click to download preset file.', 'rfbwp' ),
		'help-pos'    => 'top',
	);	*/
	
	$options[] = array(
		"name" => __( "Predefined Book Style" ), // this defines the heading of the option
		"desc" => __( "Predefined Book Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_pre_style", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "1", // deafult value of the text
		"type" => "select",
		"options" => array( 
			"none" => __( "None" ), 
			"alice" => __( "Alice" ),
			"brochure" => __( "Brochure" ),
			"catalogue" => __( "Catalogue" ),
			"comic_book" => __( "Comic Book" ),
			"company_brochure" => __( "Company Brochure" ),
			"flyer" => __( "Flyer" ),
			"lookbook" => __( "Lookbook" ),
			"magazine" => __( "Magazine" ),
			"main_preview" => __( "Main Preview" ),
			"menu" => __( "Menu" ),
			"portfolio" => __( "Portfolio" )
		),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Select predefined style for your Book. You can modify each of the settings after.' ), // text for the help tool tip
		"help-pos" => "top",
		'toggle'      => 'end',
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Book Decoration
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Border size" ), // this defines the heading of the option
		"desc" => __( "Border size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_border_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Set up books border, it\'s color and radius.'), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"toggle" => "begin",
		"toggle-name" => __( "Decorations" )
	);

	$options[] = array(
		"name" => __( "Border color:" ),
		"desc" => __( "Border color: " ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_border_color",
		"std" => "",
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Book Border Radius" ), // this defines the heading of the option
		"desc" => __( "Border radius: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_border_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"unit" => __( "px" ),
		"type" => "text-small",
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Book Outline" ),
		"desc" => __( "Book outline: " ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_outline",
		"std" => "0",
		"type" => "checkbox",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Set up books outline - line displayed outside the border.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Outline Color" ),
		"desc" => __( "Outline color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_outline_color",
		"std" => "",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Inner Page Shadows" ),
		"desc" => __( "Inner page shadow" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_inner_shadows",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable book inner shadow' ), // text for the help tool tip
		"help-pos" => "top",
		"type" => "checkbox"
	);

	$options[] = array(
		"name" => __( "Edge Page Outline" ),
		"desc" => __( "Edge page outline" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_edge_outline",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable page edge outline - it is used to create 3D like feeling. If you don\'t have border around your book we suggest disabling this feature.' ), // text for the help tool tip
		"help-pos" => "top",
		"type" => "checkbox",
		"stack" => "begin",
	);
	
	$options[] = array(
		"name" => __( "Outline Color" ),
		"desc" => __( "Outline color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_edge_outline_color",
		"std" => "",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Fullscreen" ),
		"desc" => __( "Fullscreen Overlay" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_fs_color",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the fullscreen overlay opacity, color and color of the \'X\' (close) icon.' ), // text for the help tool tip
		"help-pos" => "top",
		"std" => "#ededed",
		"type" => "color",
		"stack" => "begin",
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Opacity" ),
		"desc" => __( "Opacity:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_fs_opacity",
		"std" => "95",
		"type" => "text-small",
		"validation" => ''
	);
		
	$options[] = array(
		"name" => __( "Reverse 'X' Color" ),
		"desc" => __( "Reverse 'X' Color" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_fs_icon_color",
		"std" => "1",
		"type" => "checkbox",
		"stack" => "end",
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "New Table of Content style" ),
		"desc" => __( "New Table of Content style" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_toc_display_style",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable this option to use new Table of Content style.' ), // text for the help tool tip
		"help-pos" => "top",
		"type" => "checkbox",
		"toggle" => "end",
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Fonts Settings
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Heading Font" ), // this defines the heading of the option
		"desc" => __( "Heading Font:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_heading_font", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the font size, font family for headings.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"toggle" => "begin",
		"toggle-name" => __( "Fonts Settings" )
	);

	$options[] = array(
		"name" => __( "Family" ), // this defines the heading of the option
		"desc" => __( "Family:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_heading_family", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "Open Sans", // deafult value of the text
		"type" => "font_select",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Style" ), // this defines the heading of the option
		"desc" => __( "Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_heading_fontstyle", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "regular", // deafult value of the text
		"type" => "select",
		"validation" => '',
		"options" => array( 'regular' => __( 'Regular', 'rfbwp'), 'bold' => __( 'Bold', 'rfbwp'), 'italic' => __( 'Italic', 'rfbwp'), 'bold-italic' => __( 'Bold Italic', 'rfbwp'), )
	);

	$options[] = array(
		"name" => __( "Size" ), // this defines the heading of the option
		"desc" => __( "Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_heading_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "24", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Line Height:" ), // this defines the heading of the option
		"desc" => __( "Line Height:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_heading_line", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Color" ),
		"desc" => __( "Color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_heading_color",
		"std" => "#2b2b2b",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Content Font" ), // this defines the heading of the option
		"desc" => __( "Content Font:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_content_font", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the font size, font family for content.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
	);

	$options[] = array(
		"name" => __( "Family" ), // this defines the heading of the option
		"desc" => __( "Family:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_content_family", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "Open Sans", // deafult value of the text
		"type" => "font_select",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Style" ), // this defines the heading of the option
		"desc" => __( "Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_content_fontstyle", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "regular", // deafult value of the text
		"type" => "select",
		"validation" => '',
		"options" => array( 'regular' => __( 'Regular', 'rfbwp'), 'bold' => __( 'Bold', 'rfbwp'), 'italic' => __( 'Italic', 'rfbwp'), 'bold-italic' => __( 'Bold Italic', 'rfbwp'), )
	);

	$options[] = array(
		"name" => __( "Size" ), // this defines the heading of the option
		"desc" => __( "Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_content_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "15", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ) ,
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Line Height:" ), // this defines the heading of the option
		"desc" => __( "Line Height:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_content_line", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "25", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Color" ),
		"desc" => __( "Color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_content_color",
		"std" => "#2b2b2b",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Pagination Font" ), // this defines the heading of the option
		"desc" => __( "Pagination Font:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_font", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the font size, font family for pagination.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Family" ), // this defines the heading of the option
		"desc" => __( "Family:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_family", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "Open Sans", // deafult value of the text
		"type" => "font_select",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Style" ), // this defines the heading of the option
		"desc" => __( "Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_fontstyle", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "select",
		"validation" => '',
		"options" => array( 'regular' => __( 'Regular', 'rfbwp'), 'bold' => __( 'Bold', 'rfbwp'), 'italic' => __( 'Italic', 'rfbwp'), 'bold-italic' => __( 'Bold Italic', 'rfbwp'), )
	);

	$options[] = array(
		"name" => __( "Size" ), // this defines the heading of the option
		"desc" => __( "Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ) ,
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Line Height:" ), // this defines the heading of the option
		"desc" => __( "Line Height:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_line", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Color" ),
		"desc" => __( "Color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_num_color",
		"std" => "",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);
	
	$options[] = array( 
		"name" => __( "Table of Contents Font" ), // this defines the heading of the option
		"desc" => __( "Table of Contents Font:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_toc_font", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the font size, font family for Table of Contents.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"		
	);

	$options[] = array( 
		"name" => __( "Family" ), // this defines the heading of the option
		"desc" => __( "Family:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_toc_family", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "Open Sans", // deafult value of the text
		"type" => "font_select",
		"validation" => ''
	);
	
	$options[] = array( 
		"name" => __( "Style" ), // this defines the heading of the option
		"desc" => __( "Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_toc_fontstyle", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "select",
		"validation" => '',
		"options" => array( 'regular' => __( 'Regular', 'rfbwp'), 'bold' => __( 'Bold', 'rfbwp'), 'italic' => __( 'Italic', 'rfbwp'), 'bold-italic' => __( 'Bold Italic', 'rfbwp'), )
	);

	$options[] = array( 
		"name" => __( "Size" ), // this defines the heading of the option
		"desc" => __( "Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_toc_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ) ,
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Line Height:" ), // this defines the heading of the option
		"desc" => __( "Line Height:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_toc_line", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);
	
	$options[] = array( 
		"name" => __( "Color" ),
		"desc" => __( "Color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_toc_color",
		"std" => "",
		"type" => "color",
		"validation" => ''
	);
	
	$options[] = array( 
		"name" => __( "Hover" ),
		"desc" => __( "Hover:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_toc_colorhover",
		"std" => "",
		"type" => "color",
		"stack" => "end",
		"toggle" => "end",
		"validation" => ''
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Zoom Settings
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Zoom Border Size" ), // this defines the heading of the option
		"desc" => __( "Border size: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_zoom_border_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify parameters for the border that is displayed around the zoomed page.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"toggle" => "begin",
		"toggle-name" => __( "Zoom Settings" )
	);

	$options[] = array(
		"name" => __( "Zoom Border Color" ),
		"desc" => __( "Border color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_zoom_border_color",
		"std" => "#ECECEC",
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Zoom Border Radius" ), // this defines the heading of the option
		"desc" => __( "Border radius:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_zoom_border_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Zoom Outline" ),
		"desc" => __( "Outline: " ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_zoom_outline",
		"std" => "1",
		"type" => "checkbox",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable zoom panel outline, specify it\'s color.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Zoom Outline Color" ),
		"desc" => __( "Outline color: " ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_zoom_outline_color",
		"std" => "#D0D0D0",
		"type" => "color",
		"stack" => "end",
		"toggle" => "end",
		"validation" => ''
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Show All Pages
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Thumbnail Columns" ), // this defines the heading of the option
		"desc" => __( "Thumbnail Columns:"), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_thumb_cols", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "3", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Show all pages panel contains thumbnails of each page, here you can specify number of columns of those thumbnails.' ), // text for the help tool tip
		"help-pos" => "top",
		"toggle" => "begin",
		"toggle-name" => __( "Show all pages settings" )
	);

	$options[] = array(
		"name" => __( "Thumbnail Border Size" ), // this defines the heading of the option
		"desc" => __( "Thumbnail border size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_thumb_border_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "1", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Border Size - displayed around all thumbnails.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Thumbnail Border Color" ),
		"desc" => __( "Border color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_sa_thumb_border_color",
		"std" => "#878787",
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Vertical Padding" ), // this defines the heading of the option
		"desc" => __( "Vertical padding: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_vertical_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify thumbnails vertical and horizontal padding.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Horizontal Padding" ), // this defines the heading of the option
		"desc" => __( "Horizontal padding:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_horizontal_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end"
	);


	$options[] = array(
		"name" => __( "Panel Border Size" ), // this defines the heading of the option
		"desc" => __( "Border size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_border_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify parameters for the show all pages panel border. This border is displayed around all of the thumbnails.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Panel Border Color" ),
		"desc" => __( "Border color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_sa_border_color",
		"std" => "#F6F6F6",
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Panel Border Radius" ), // this defines the heading of the option
		"desc" => __( "Border radius:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_sa_border_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Panel Outline" ),
		"desc" => __( "Panel outline: " ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_sa_outline",
		"std" => "1",
		"type" => "checkbox",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify show all pages panel outline - outline is a 1px line displayed around the border.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Panel Outline Color" ),
		"desc" => __( "Outline color:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_fb_sa_outline_color",
		"std" => "#D6D6D6",
		"type" => "color",
		"stack" => "end",
		"toggle" => "end",
		"validation" => ''
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Navigation Settings
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Compact Mode" ), // this defines the heading of the option
		"desc" => __( "Compact Mode:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_menu_type", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"type" => "checkbox",
		//"options" => array("Compact" => __( "Compact" ), "Spread" => __( "Spread" ) ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable Compact mode to display navigation sticking to book. '
				. '<br /><br />Enable Stack buttons if you want to display the radius border only on first and last buttons.'
				. '<br /><br />Choose the position of the menu from Menu Alignment options'
				. '<br /><br />Enable Text buttons to display predefined text instead of icons.'), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"toggle" => "begin",
		"toggle-name" => __( "Navigation Settings" )
	);

	$options[] = array(
		"name" => __( "Menu alignment" ), // this defines the heading of the option
		"desc" => __( "Menu alignment:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_menu_position", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "bottom", // deafult value of the text
		"type" => "select",
		"options" => array("bottom" => __( "Bottom" ), "top" => __( "Top" ), "aside left" => __( "Aside Left" ), "aside right" => __( "Aside Right" ) )
	);

	$options[] = array(
		"name" => __( "Stack buttons" ), // this defines the heading of the option
		"desc" => __( "Stack buttons:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_stack", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable buttons stack.' ), // text for the help tool tip
		"help-pos" => "top",
	);
	
	$options[] = array( 
		"name" => __( "Text buttons" ), // this defines the heading of the option
		"desc" => __( "Text buttons:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_text", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable buttons with only texts.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Table of Contents" ), // this defines the heading of the option
		"desc" => __( "Table of contents:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_toc", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Table of Contents button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Menu Order" ), // this defines the heading of the option
		"desc" => __( "Menu order:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_toc_order", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "1", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Page Index" ), // this defines the heading of the option
		"desc" => __( "Page index:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_toc_index", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Icon" ), // this defines the heading of the option
		"desc" => __( "Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_toc_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-th-list", // deafult value of the text
		"type" => "icon",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Zoom" ), // this defines the heading of the option
		"desc" => __( "Zoom:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_zoom", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Zoom button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Menu Order" ), // this defines the heading of the option
		"desc" => __( "Menu order:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_zoom_order", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Zoom In Icon" ), // this defines the heading of the option
		"desc" => __( "Zoom Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_zoom_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-search-plus", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Zoom Out Icon" ), // this defines the heading of the option
		"desc" => __( "Zoon Out Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_zoom_out_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-search-minus", // deafult value of the text
		"type" => "icon",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Slide show" ), // this defines the heading of the option
		"desc" => __( "Slide show:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_ss", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Slide Show button and delay between the slides.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Menu Order" ), // this defines the heading of the option
		"desc" => __( "Menu order:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_ss_order", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "3", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Play Icon" ), // this defines the heading of the option
		"desc" => __( "Play Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_ss_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-play", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Stop Icon" ), // this defines the heading of the option
		"desc" => __( "Stop Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_ss_stop_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-pause", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Delay" ), // this defines the heading of the option
		"desc" => __( "Delay:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_ss_delay", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2000", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "ms" ),
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Show all pages" ), // this defines the heading of the option
		"desc" => __( "Show all pages:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Show All Pages button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Menu Order" ), // this defines the heading of the option
		"desc" => __( "Menu order:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap_order", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "4", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Prev" ), // this defines the heading of the option
		"desc" => __( "Prev:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap_icon_prev", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-chevron-up", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Next" ), // this defines the heading of the option
		"desc" => __( "Next:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap_icon_next", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-chevron-down", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);
	
	$options[] = array(
		"name" => __( "Icon" ), // this defines the heading of the option
		"desc" => __( "Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-th", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Close Icon" ), // this defines the heading of the option
		"desc" => __( "Close Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_sap_icon_close", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-times", // deafult value of the text
		"type" => "icon",
		"stack" => "end",
		"validation" => ''
	);
	

	$options[] = array(
		"name" => __( "Fullscreen" ), // this defines the heading of the option
		"desc" => __( "Fullscreen:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_fs", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Fullscreen button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Menu Order" ), // this defines the heading of the option
		"desc" => __( "Menu order:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_fs_order", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "5", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);

	$options[] = array(
		"name" => __( "Icon" ), // this defines the heading of the option
		"desc" => __( "Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_fs_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-expand", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Close Icon" ), // this defines the heading of the option
		"desc" => __( "Close Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_fs_close_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-compress", // deafult value of the text
		"type" => "icon",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Arrows" ), // this defines the heading of the option
		"desc" => __( "Arrows:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_arrows", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable/Disable Next/Previous navigation buttons.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Group with Navbar" ), // this defines the heading of the option
		"desc" => __( "Group with Navbar:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_arrows_toolbar", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0"
	);

	$options[] = array(
		"name" => __( "Prev Icon" ), // this defines the heading of the option
		"desc" => __( "Prev Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_prev_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-chevron-left", // deafult value of the text
		"type" => "icon",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Next Icon" ), // this defines the heading of the option
		"desc" => __( "Next Icon:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_next_icon", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "fa fa-chevron-right", // deafult value of the text
		"type" => "icon",
		"validation" => '',
		"stack" => "end",
		"toggle" => "end",
	);
	
	/*$options[] = array(
		"name" => __( "Tight Arrows" ), // this defines the heading of the option
		"desc" => __( "Tight Arrows:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_tight_arrows", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "false", 
		"stack" => "end",
		"toggle" => "end",
	);*/

	/*-----------------------------------------------------------------------------------*/
	/*	Navigation Style
	/*-----------------------------------------------------------------------------------*/
	$options[] = array(
		"name" => __( "Enable General Style" ), // this defines the heading of the option
		"desc" => __( "Enable General Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the general style (padding, margin, font size, bottom border) nav button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"toggle" => "begin",
		"toggle-name" => __( "Navigation Style" )
	);

	$options[] = array(
		"name" => __( "Vertical Padding" ), // this defines the heading of the option
		"desc" => __( "Vertical Padding:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_v_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "15", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ) ,
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Horizontal Padding" ), // this defines the heading of the option
		"desc" => __( "Horizontal Padding:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_h_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "15", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Margin " ), // this defines the heading of the option
		"desc" => __( "Margin:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_margin", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "20", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ) ,
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Font size" ), // this defines the heading of the option
		"desc" => __( "Font Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_fontsize", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "22", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Border Size" ), // this defines the heading of the option
		"desc" => __( "Border Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_bordersize", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Buttons shadow" ), // this defines the heading of the option
		"desc" => __( "Buttons shadow:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_general_shadow", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"type" => "checkbox",
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Regular State" ), // this defines the heading of the option
		"desc" => __( "Regular State:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_default", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the color, background color, font size, buttons border radius for default (unactive) button.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Color" ), // this defines the heading of the option
		"desc" => __( "Color:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_default_color", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "#2b2b2b", // deafult value of the text
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Background" ), // this defines the heading of the option
		"desc" => __( "Background:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_default_background", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Hover State" ), // this defines the heading of the option
		"desc" => __( "Hover State:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_hover", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify the color, background color, font size, buttons border radius for button hover.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Color" ), // this defines the heading of the option
		"desc" => __( "Color:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_hover_color", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "#22b4d8", // deafult value of the text
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Background" ), // this defines the heading of the option
		"desc" => __( "Background:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_hover_background", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Regular Border State" ), // this defines the heading of the option
		"desc" => __( "Regular Border State:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_default", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable border styles for buttons.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Color" ), // this defines the heading of the option
		"desc" => __( "Color:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_color", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color"
	);

	$options[] = array(
		"name" => __( "Radius" ), // this defines the heading of the option
		"desc" => __( "Radius:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Hover Border State" ), // this defines the heading of the option
		"desc" => __( "Hover Border State:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_hover", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "1",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable border styles for hover buttons.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Color" ), // this defines the heading of the option
		"desc" => __( "Color:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_hover_color", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Radius" ), // this defines the heading of the option
		"desc" => __( "Radius:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_nav_border_hover_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end",
		"toggle" => "end",
		"validation" => ''
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Numeration Settings
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => __( "Enable Pagination display" ), // this defines the heading of the option
		"desc" => __( "Enable Pagination display:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "0", // deafult value of the text
		"type" => "checkbox",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Select this option to enable automatic pagination display.' ), // text for the help tool tip
		"help-pos" => "top",
		"toggle" => "begin",
		"toggle-name" => __( "Pagination Settings" ),
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Hide on first & last page" ), // this defines the heading of the option
		"desc" => __( "Hide on first & last page:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_hide", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "1", // deafult value of the text
		"type" => "checkbox",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		//"help-desc"  => __( 'Hide numeration on first and last page of book.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Style" ), // this defines the heading of the option
		"desc" => __( "Style:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_style", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify background color.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Background" ), // this defines the heading of the option
		"desc" => __( "Background:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_background", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Border" ), // this defines the heading of the option
		"desc" => __( "Border:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_border", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "checkbox",
		"std" => "0",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Enable border styles for pagination.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Color" ), // this defines the heading of the option
		"desc" => __( "Color:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_border_color", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "", // deafult value of the text
		"type" => "color",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Size" ), // this defines the heading of the option
		"desc" => __( "Size:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_border_size", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Radius" ), // this defines the heading of the option
		"desc" => __( "Radius:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_border_radius", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "2", // deafult value of the text
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end" ,
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Vertical Position" ), // this defines the heading of the option
		"desc" => __( "Vertical Position:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_v_position", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "select",
		"std" => "1",
		"options" => array( "top" => _( "Top"), "bottom" => __( "Bottom" ) ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Select Vertical position for pagination.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Horizontal Position" ), // this defines the heading of the option
		"desc" => __( "Horizontal Position:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_h_position", // the id must be unique, it is used to call back the propertie inside the them
		"type" => "select",
		"std" => "1",
		"options" => array( "center" => _( "Center"), "aside" => __( "Aside" ) ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Select Horizontical position for pagination.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "end",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Vertical Padding" ), // this defines the heading of the option
		"desc" => __( "Vertical padding: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_v_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "12", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify pagination vertical and horizontal padding.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Horizontal Padding" ), // this defines the heading of the option
		"desc" => __( "Horizontal padding:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_h_padding", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end"
	);

	$options[] = array(
		"name" => __( "Vertical Margin" ), // this defines the heading of the option
		"desc" => __( "Vertical Margin: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_v_margin", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "12", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( 'Specify pagination vertical and horizontal margin.' ), // text for the help tool tip
		"help-pos" => "top",
		"stack" => "begin"
	);

	$options[] = array(
		"name" => __( "Horizontal Margin" ), // this defines the heading of the option
		"desc" => __( "Horizontal Margin:" ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_num_h_margin", // the id must be unique, it is used to call back the propertie inside the them
		"std"  => "10", // deafult value of the text
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small",
		"unit" => __( "px" ),
		"stack" => "end",
		"toggle" => "end"
	);

	/*----------------------------------------------------------------------------*\
		HARD COVER - Settings
	\*----------------------------------------------------------------------------*/
	$options[ ] = array(
		'name'        => __( 'Enable hard cover', 'rfbwp' ),
		'desc'        => __( 'Enable hard cover:', 'rfbwp' ),
		'desc-pos'    => 'top',
		'id'          => $rfbwp_shortname . '_fb_hc',
		'std'         => '0',
		'type'        => 'checkbox',
		'help'        => 'true',
		'help-desc'   => __( 'Select this option to enable hard covers.', 'rfbwp' ),
		'help-pos'    => 'top',
		'toggle'      => 'begin',
		'toggle-name' => __( 'Hard Cover', 'rfbwp' ),
	);

	$options[ ] = array(
		'name'       => __( 'Choose front cover outside image', 'rfbwp' ),
		'desc'       => __( 'Choose front cover outside image:', 'rfbwp' ),
		'id'         => $rfbwp_shortname . '_fb_hc_fco',
		'help'       => 'true',
		'help-desc'  => __( 'Specify images for front cover.', 'rfbwp' ),
		'help-pos'   => 'left',
		'class'      => /*$rfbwp_shortname . '-hard-cover-left ' .*/ $rfbwp_shortname . '-page-bg-image',
		'token'      => $rfbwp_shortname . '_0',
		'stack'      => 'begin',
//		'float'      => 'left',
		'std'        => '',
		'validation' => '',
		'type'       => 'upload',
	);
	$options[ ] = array(
		'name'       => __( 'Choose front cover inside image', 'rfbwp' ),
		'desc'       => __( 'Choose front cover inside image:', 'rfbwp' ),
		'id'         => $rfbwp_shortname . '_fb_hc_fci',
//		'help'       => 'true',
//		'help-desc'  => __( 'Specify pages background image.', 'rfbwp' ),
//		'help-pos'   => 'left',
		'class'      => /*$rfbwp_shortname . '-hard-cover-right ' .*/ $rfbwp_shortname . '-page-bg-image',
		'token'      => $rfbwp_shortname . '_0',
		'stack'      => 'end',
//		'float'      => 'right',
		'std'        => '',
		'validation' => '',
		'type'       => 'upload',
	);
	$options[] = array(
		'name'     => __( 'Front cover side' ),
		'desc'     => __( 'Front cover side:' ),
		'desc-pos' => 'top',
		'id'       => $rfbwp_shortname . '_fb_hc_fcc',
		'std'      => '#dddddd',
		'type'     => 'color',
	);

	$options[ ] = array(
		'name'       => __( 'Choose back cover outside image', 'rfbwp' ),
		'desc'       => __( 'Choose back cover outside image:', 'rfbwp' ),
		'id'         => $rfbwp_shortname . '_fb_hc_bco',
		'help'       => 'true',
		'help-desc'  => __( 'Specify images for back cover.', 'rfbwp' ),
		'help-pos'   => 'left',
		'class'      => /*$rfbwp_shortname . '-hard-cover-left ' .*/ $rfbwp_shortname . '-page-bg-image',
		'token'      => $rfbwp_shortname . '_0',
		'stack'      => 'begin',
//		'float'      => 'left',
		'std'        => '',
		'validation' => '',
		'type'       => 'upload',
	);
	$options[ ] = array(
		'name'       => __( 'Choose back cover inside image', 'rfbwp' ),
		'desc'       => __( 'Choose back cover inside image:', 'rfbwp' ),
		'id'         => $rfbwp_shortname . '_fb_hc_bci',
//		'help'       => 'true',
//		'help-desc'  => __( 'Specify pages background image.', 'rfbwp' ),
//		'help-pos'   => 'left',
		'class'      => /*$rfbwp_shortname . '-hard-cover-right ' .*/ $rfbwp_shortname . '-page-bg-image',
		'token'      => $rfbwp_shortname . '_0',
		'stack'      => 'end',
//		'float'      => 'right',
		'std'        => '',
		'validation' => '',
		'type'       => 'upload',
	);
	$options[] = array(
		'name'     => __( 'Back cover side' ),
		'desc'     => __( 'Back cover side:' ),
		'desc-pos' => 'top',
		'id'       => $rfbwp_shortname . '_fb_hc_bcc',
		'std'      => '#dddddd',
		'type'     => 'color',
		'toggle'   => 'end',
	);

	/*-----------------------------------------------------------------------------------*/
	/*	Books Pages
	/*-----------------------------------------------------------------------------------*/

	$options[] = array(
		"name" => "Pages_0", // Options of type heading represent tabs for sections
		"type" => "heading",
		"sub" => "pages"
	);

	$options[] = array(
		"name" => __( "Pages" ),
		"type" => "pages",
		"id" => $rfbwp_shortname."_pages"
	);

	$options[] = array(
		"name" => "Page_0", // Options of type heading represent tabs for sections
		"type" => "separator",
		"id" => $rfbwp_shortname."_page_separator",
		"sub" => "pages"
	);

	$options[] = array(
		"name" => __( "Page Type" ), // this defines the heading of the option
		"desc" => "", // this is the field/option description
		"id"   => $rfbwp_shortname."_fb_page_type", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-type",
		"std"  => "Single Page", // deafult value of the text
		"options" => array("Single Page" => __( "Single Page" ), "Double Page" => __( "Double Page" )), /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Select page type:</br> - single - normal single page (left or right), </br> - double - one image displayed across both pages (left and right). " ), // text for the help tool tip
		"help-pos" => "right",
		"stack" => "begin",
		"type" => "select",
		"validation" => ''
	);

	$options[] = array(
		"name" => __( "Page Preview" ), // this defines the heading of the option
		"id"   => $rfbwp_shortname."_fb_page_preview", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-preview",
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"tooltip"  => __( "Page Preview" ), // text for the help tool tip
		"stack" => "end",
		"color" => "grey",
		"icon" => "preview",
		"float" => "right", // default none
		"type" => "button"
	);

	$options[] = array(
		"name" => __( "Background Image" ), // this defines the heading of the option
		"desc" => __( "Choose page background:" ), // this is the field/option description
		"id"   => $rfbwp_shortname."_fb_page_bg_image", // the id must be unique, it is used to call back the propertie inside the them
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Specify pages background image." ), // text for the help tool tip
		"help-pos" => "right",
		"class" => $rfbwp_shortname."-page-bg-image",
		"token" => $rfbwp_shortname."_0",
		"std"  => "", // deafult value of the text
		"stack" => "begin",
		"float"	=> "left",
		"validation" => "numeric", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "upload"
	);


	$options[] = array(
		"name" => __( "Background Image Zoom" ), // this defines the heading of the option
		"desc" => __( "Choose page hi-res background:" ), // this is the field/option description
		"id"   => $rfbwp_shortname."_fb_page_bg_image_zoom", // the id must be unique, it is used to call back the propertie inside the them
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Specify hi-res page background images, it is used by the zoom feature (optional)." ), // text for the help tool tip
		"class" => $rfbwp_shortname."-page-bg-image-zoom",
		"token" => $rfbwp_shortname."_0",
		"stack" => "end",
		"float" => "right",
		"std"  => "", // deafult value of the text
		"validation" => "", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "upload"
	);

	$options[] = array(
		"name" => __( "Page Title" ), // this defines the heading of the option
		"desc" => __( "Page Title: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_page_title", // the id must be unique, it is used to call back the propertie inside the them
		/* "class" => $rfbwp_shortname."-page-index", */
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Specify page title." ), // text for the help tool tip
		"std"  => "", // deafult value of the text
		"validation" => "", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-medium"
	);

	$options[] = array(
		"name" => __( "Page Index" ), // this defines the heading of the option
		"desc" => __( "Page Index: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_page_index", // the id must be unique, it is used to call back the propertie inside the them
		/* "class" => $rfbwp_shortname."-page-index", */
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Specify page index (better leave default value)." ), // text for the help tool tip
		"std"  => "", // deafult value of the text
		"validation" => "", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-small"
	);
	
	$options[ ] = array(
		'name'        => __( 'Page URL', 'rfbwp' ),
		'desc'        => __( 'Page URL:', 'rfbwp' ),
		'desc-pos'    => 'top',
		'id'          => $rfbwp_shortname . '_fb_page_url',
		'std'         => '',
		'type'        => 'text-medium',
		'help'        => 'true',
		'help-desc'   => __( 'Specify the page URL. After that the whole page would work as a link to specified URL (leave empty to disable).', 'rfbwp' ),
		'help-pos'    => 'top',
		"validation" => ''
	);

	$options[] = array(
		"name" => "", // this defines the heading of the option
		"id"   => $rfbwp_shortname."_fb_page_columns_sc", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-columns-sc revert",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		//"tooltip"  => __( "Show Right Column" ), // text for the help tool tip
	/* 	"stack" => "end", */
		"icon" => "dashicons-admin-page",
		"float" => "right", // default none
		"type" => "button"
	);

	$options[] = array(
		"name" => "", // this defines the heading of the option
		"id"   => $rfbwp_shortname."_fb_page_toc_popup", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-toc-popup revert",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		//"tooltip"  => __( "Show TOC generator" ), // text for the help tool tip
	/* 	"stack" => "end", */
		"icon" => "dashicons-editor-ul",
		"float" => "right", // default none
		"type" => "button"
	);

	$options[] = array(
		"name" => __( "Left Page Content" ),
		"desc" => __( "Left Page Content:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_page_html",
		"help-desc"  => __( "Here you can specify the HTML content which will be displayed on the page or left page (double page). To easily place content in two columns (for left and right pages) use the button alongside." ),
		"help-pos" => "right",
		"std" => "",
		"validation" => "",
		"wp-editor" => true,
		"type" => "textarea-big"
	);

	$options[] = array(
		"name" => "", // this defines the heading of the option
		"id"   => $rfbwp_shortname."_fb_page_toc_popup_second", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-toc-popup revert",
		"help" => "false", // should the help icon be displayed (not working yet, better add this to your settings)
		//"tooltip"  => __( "Show TOC generator" ), // text for the help tool tip
	/* 	"stack" => "end", */
		"icon" => "dashicons-editor-ul",
		"float" => "right", // default none
		"type" => "button"
	);

	$options[] = array(
		"name" => __( "Right Page Content" ),
		"desc" => __( "Right Page Content:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_page_html_second",
		"help-desc"  => __( "Here you can specify the HTML content which will be displayed on the right page." ),
		"help-pos" => "right",
		"std" => "",
		"validation" => "",
		"wp-editor" => true,
		"type" => "textarea-big"
	);	
	
	$options[] = array(
		"name" => __( "Page Custom Class" ), // this defines the heading of the option
		"desc" => __( "Page Custom Class: " ), // this is the field/option description
		"desc-pos" => "top",
		"id"   => $rfbwp_shortname."_fb_page_custom_class", // the id must be unique, it is used to call back the propertie inside the them
		/* "class" => $rfbwp_shortname."-page-index", */
		"help" => "true", // should the help icon be displayed (not working yet, better add this to your settings)
		"help-desc"  => __( "Specify page custom class (NOTE: Use it in the Page CSS field to target current page)." ), // text for the help tool tip
		"std"  => "", // deafult value of the text
		"validation" => "", /* Each text field can be specialy validated, if the text wont be using HTML tags you can choose here 'nohtml' ect. Choose Between: numeric, multinumeric, nohtml, url, email or dont set it for standard  validation*/
		"type" => "text-medium"
	);

	$options[] = array(
		"name" => __( "Page CSS" ),
		"desc" => __( "Page CSS:" ),
		"desc-pos" => "top",
		"id" => $rfbwp_shortname."_page_css",
		"help" => "true",
		"help-desc"  => __( "Here you can specify the CSS which will be applied to the page." ),
		"help-pos" => "right",
		"std" => "",
		"validation" => "",
		"type" => "textarea"
	);

	$options[] = array(
		"name" => __( "Save Page" ), // this defines the heading of the option
		"id"   => $rfbwp_shortname."_fb_page_save", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-page-save revert",
		"type" => "button",
		"icon" => "dashicons-edit"
	);

	////////////////////////////////////////////////////////////////////////

	$options[] = array(
		"name" => __( "Help" ), // When option is type section that mean that it will be displayed as button on the left
		"sub-name" => __( "Support" ),
		"icon" => "", // icon has to be placed in massive-panel/images/icons folder
		"icon-active" => "",
		"type" => "section"
	);

	$options[] = array(
		"name" => __( "Help1" ), // Options of type heading represent tabs for sections
		"type" => "heading"
	);

	$options[] = array(
		"name" => __( "Help2" ), // this defines the heading of the option
		"id"   => $rfbwp_shortname."_notice", // the id must be unique, it is used to call back the propertie inside the them
		"class" => $rfbwp_shortname."-notice",
	/* 	"stack" => "end", */
		"desc" => __( 'You are using Responsive Flip Book WordPress Plugin v1.4.<br><br>If you have a support question please visit our <a href="http://mpc.ticksy.com" target="_blank">support site</a>. If you are looking for a documentation you can find it inside the ZIP file downloaded from CodeCanyon.' ),
		"color" => "yellow",
		"float" => "right", // default none
		"type" => "info"
	);

	/////////////////////////////////////////////////////////////////////

	$plugin_data = get_plugin_data( MPC_PLUGIN_FILE );

	// header settings, main heading and socials
	$options[] = array("name" => __( "FlipBook" ), // this is the main heading from thr header
		"desc" => 'v' . $plugin_data['Version'], // this is the line of description used in the header
		"type" => "top-header");

	$options[] = array("options" => $social_array,
		"type" => "top-socials");

	return $options;
}


?>
